Subject: RE: phoenix lambda-lambda for_each example
From: "Noah Stein" <[email-masked]>
To: "Joel de Guzman" <[email-masked]>, "David Abrahams" <[email-masked]>
Cc: "Aleksey Gurtovoy" <[email-masked]>, "Noah Stein" <[email-masked]>, "Jaakko Jarvi" <[email-masked]>
Date: Wed, 3 Mar 2004 11:56:52 -0800

> From: Joel de Guzman [mailto:[email-masked]]

> Sent: Wednesday, March 03, 2004 7:43 AM
> To: David Abrahams
> Cc: Aleksey Gurtovoy; Noah Stein; Jaakko Jarvi
> Subject: Re: phoenix lambda-lambda for_each example

> How about a compromise:
>
>      for_each[seq](seq, push_back(seq, arg1))
>
> But hey! We can probably have absolute place-holders
> and scope-relative place-holders at the same time:
>
>      for_each(seq, push_back(seq, arg1))
>
> where seq is an absolute place-holder referring to the
> outermost scope where it is first seen and arg1 is a
> scope-relative place-holder (as usual).
>
> <<< Perhaps that's what Noah meant. Hmmm... Now,
> I wonder how difficult it would be to implement that. >>>

This is essentially what I was talking about.  Your scheme would be much,
much easier to implement than my suggestion.  I would like to see if we're
on the same page.  In my plan, seq would be a place holder object (similar
to say an argument<> object) that would become an identifier for binding
when placed in the brackets.  How would you propose handling the binding of
only a second parameter?  I don't think that matters for the STL algorithms,
but I could imagine it might for a general case.

-- Noah